
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【四】——实现模型工厂，依赖注入以及格式配置 / iVAN</title>

    <meta name="description" content="使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【四】——实现模型工厂，依赖注入以及格式配置 原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[四]--实现模型工厂,依赖注入以及格式配置 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 在上一篇中,我们已经初步开始使用Web Api了,但同时出现了一些很多不足之处,本章我们就着重来解决这些不足. 上篇导航:http://www.cnblogs.com/fzrain/p/3510035.html 配置JSON的格式 Web Api提供Xml和JSON作">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【四】——实现模型工厂，依赖注入以及格式配置</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://www.cnblogs.com/fzrain/p/3520442.html" rel="external nofollow noreferrer">使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【四】——实现模型工厂，依赖注入以及格式配置</a><br />
<br />系列导航地址<a href="http://www.cnblogs.com/fzrain/p/3490137.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fzrain/p/3490137.html</a></p>
<p>前言</p>
<p>在上一篇中，我们已经初步开始使用Web Api了，但同时出现了一些很多不足之处，本章我们就着重来解决这些不足。</p>
<p>上篇导航：<a href="http://www.cnblogs.com/fzrain/p/3510035.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fzrain/p/3510035.html</a></p>
<p>配置JSON的格式</p>
<p>Web Api提供Xml和JSON作为返回数据的格式，框架会自动把这些格式注入管线。客户端可以通过Http请求头部来声明需要的数据格式，我们可以通过在“WebApiConfig”这个类来配置JSON数据的格式：</p>
<pre>public static class WebApiConfig
   {
        public static void Register(HttpConfiguration config)
        {
        var jsonFormatter = config.Formatters.OfType&lt;JsonMediaTypeFormatter&gt;().First();   </pre>
<pre>     jsonFormatter.SerializerSettings.ContractResolver = new CamelCasePropertyNamesContractResolver();</pre>
<pre>   }
    }</pre>
<p>首先根据HttpConfiguration对象获得jsonFormatter对象，然后设置ContractResolver属性。那么以后当我们使用JSON数据格式的时候就是“Camel”风格的了。</p>
<p>用Ninject实现依赖注入</p>
<p>如果读者是第一次接触依赖注入这个概念的话，可以参考：<a href="http://www.cnblogs.com/xray2005/archive/2009/07/28/1532908.html" rel="external nofollow noreferrer">http://www.cnblogs.com/xray2005/archive/2009/07/28/1532908.html</a></p>
<p>OK，接下来我们就来实现依赖注入，在Controller文件夹中创建一个类“BaseApiController”继承自“APIController”。由于我们打算使用构造函数注入模式，因此它的构造函数接受一个ILearning类型的变量，下面上代码：</p>
<pre>public class BaseApiController : ApiController
    {
        private ILearningRepository _repo;

        public BaseApiController(ILearningRepository repo)
        {
            _repo = repo;
        }

        protected ILearningRepository TheRepository
        {
            get
            {
                return _repo;
            }
        }
    }</pre>
<p>将我们的“CoursesController”继承自“BaseApiController”，接下来就是使用Ninject框架来建立2者之间的关联：</p>
<p>首先使用NuGet来添加3个程序集：</p>
<ul>
<li>Ninject</li>
<li>Ninject.Web.Common</li>
<li>WebApiContrib.IoC.Ninject</li>
</ul>
<p>添加好上述引用后，在APP_Start文件夹下就会出现一个类“NinjectWebCommon”，这个类就是在我们项目中配置依赖关系的。在之前的系列中，我们创建了“LearningRepository”，在它的构造函数中需要接受一个LearningContext对象（前篇导航：<a href="http://www.cnblogs.com/fzrain/p/3503952.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fzrain/p/3503952.html</a>），因此我们也将这个依赖关系配置进来：</p>
<pre>public static class NinjectWebCommon
    {

        private static IKernel CreateKernel()
        {
            var kernel = new StandardKernel();
            kernel.Bind&lt;Func&lt;IKernel&gt;&gt;().ToMethod(ctx =&gt; () =&gt; new Bootstrapper().Kernel);
            kernel.Bind&lt;IHttpModule&gt;().To&lt;HttpApplicationInitializationHttpModule&gt;();

            //Suport WebAPI Injection
            GlobalConfiguration.Configuration.DependencyResolver = new WebApiContrib.IoC.Ninject.NinjectResolver(kernel);

            RegisterServices(kernel);
            return kernel;
        }

        private static void RegisterServices(IKernel kernel)
        {
            kernel.Bind&lt;LearningContext&gt;().To&lt;LearningContext&gt;().InRequestScope();
            kernel.Bind&lt;ILearningRepository&gt;().To&lt;LearningRepository&gt;().InRequestScope();
        }
    }</pre>
<p>我们使用了Ninject配置了Learningcontext对象，使得在http请求范围共用一个context对象，这么做对于创建复杂对象是非常好的。关于Ninject对象范围，可以参考：<a href="http://music.573114.com/Blog/Html/EB43/815024.html" rel="external nofollow noreferrer">http://music.573114.com/Blog/Html/EB43/815024.html</a></p>
<p>实现模型工厂模式</p>
<p>模型工厂帮助我们创建需要响应给客户端的模型，因此我们将创建一些区别于领域模型（domain model）的新模型，新模型将与领域模型映射。例如：“Course”将映射到”courseModel”,”Tutor”将映射到“TutorModel“。同时应当考虑对象间的依赖关系。</p>
<p>为了实现这个功能，我们在”Model”文件夹中创建这几个类”SubjectModel“，”TutorModel“，”CourseModel“，”EnrollmentModel“，这些类就是一些简单的”POCO”类，用来响应给客户端的，下面上代码：</p>
<pre>public class SubjectModel
{
    public int Id { get; set; }
    public string Name { get; set; }
}

public class TutorModel
{
    public int Id { get; set; }
    public string Email { get; set; }
    public string UserName { get; set; }
    public string FirstName { get; set; }
    public string LastName { get; set; }
    public Data.Enums.Gender Gender { get; set; }

}

public class CourseModel
{
    public int Id { get; set; }
    public string Url { get; set; }
    public string Name { get; set; }
    public double Duration { get; set; }
    public string Description { get; set; }
    public TutorModel Tutor { get; set; }
    public SubjectModel Subject { get; set; }

}

public class EnrollmentModel
{
    public DateTime EnrollmentDate { get; set; }
    public CourseModel Course { get; set; }
}</pre>
<p>有了这些响应给客户端的类，我们还需要一个创建这些类对象的工厂——”ModelFactory“：</p>
<pre>public class ModelFactory
    {
        public ModelFactory()
        {

        }

        public CourseModel Create(Course course)
        {
            return new CourseModel()
            {
                Id = course.Id,
                Name = course.Name,
                Duration = course.Duration,
                Description = course.Description,
                Tutor = Create(course.CourseTutor),
                Subject = Create(course.CourseSubject)
            };
        }

        public TutorModel Create(Tutor tutor)
        {
            return new TutorModel()
            {
                Id = tutor.Id,
                Email = tutor.Email,
                UserName = tutor.UserName,
                FirstName = tutor.FirstName,
                LastName = tutor.LastName,
                Gender = tutor.Gender
            };
        }

        public SubjectModel Create(Subject subject)
        {
            return new SubjectModel()
            {
                Id = subject.Id,
                Name = subject.Name
            };
        }

        public EnrollmentModel Create(Enrollment enrollment)
        {
            return new EnrollmentModel()
            {
                EnrollmentDate = enrollment.EnrollmentDate,
                Course =  Create(enrollment.Course)
            };
        }
    }</pre>
<p>我们做的很简单，重载了Create方法，传入领域模型即可创建我们响应给客户端的模型，在这里我们可以很轻易的控制对象间的依赖关系（CourseModel引用TutorModel，CourseModel引用SubjectModel）</p>
<p>到此为止我们已经解决了2个瑕疵：</p>
<p>   （1）对象间的循环依赖</p>
<p>   （2）控制了返回客户端的字段（Password不会响应给客户端了）</p>
<p>由于我们可能要在各个Controller中使用到ModelFactory对象，因此我们在BaseController中添加如下代码：</p>
<pre>public class BaseApiController : ApiController
    {
         private ModelFactory _modelFactory;

         protected ModelFactory TheModelFactory
        {
            get
            {
                if (_modelFactory == null)
                {
                    _modelFactory = new ModelFactory();
                }
                return _modelFactory;
            }
        }
    }</pre>
<p>在介绍”CoursesController”的变化之前，我们先解决一下之前提到的2个问题：</p>
<p>   （1）对于每个资源返回一个URI</p>
<p>   （2）对于单个资源返回一个Http响应码</p>
<p><strong>为每个资源添加URI：</strong></p>
<p>做法不复杂因为我们已经创建了模型工厂，举个简单的例子——如果我们要返回一个URI，要通过一下步骤：</p>
<p>   1.给ModelFactory的构造函数传入一个”HttpRequestMessage“对象来创建”System.Web.Http.Routing.UrlHelper“对象，它会根据我们在WebApiConfig中配置的路由名字来构造URI</p>
<p>   2.在”BaseApiController“中的”ModelFactory“构造函数中传入”System.Web.Http.Routing.UrlHelper“对象</p>
<p>   3.在”CourseModel”中新增一个属性”URL“</p>
<pre>public class ModelFactory
    {
        private System.Web.Http.Routing.UrlHelper _UrlHelper;

        public ModelFactory(HttpRequestMessage request)
        {
            _UrlHelper = new System.Web.Http.Routing.UrlHelper(request);
        }
    }</pre>
<pre>public class BaseApiController : ApiController
    {
         private ModelFactory _modelFactory;

         protected ModelFactory TheModelFactory
        {
            get
            {
                if (_modelFactory == null)
                {
                    _modelFactory = new ModelFactory(Request);
                }
                return _modelFactory;
            }
        }
    }</pre>
<pre>class ModelFactory
    {
        public CourseModel Create(Course course)
        {
            return new CourseModel()
            {
                Url = _UrlHelper.Link(“Courses”, new { id = course.Id }),
                Id = course.Id,
                /*Other CourseModel properties remain the same*/
            };
        }</pre>
<p>关于模型工厂的更多介绍，可以参考：<a href="http://pluralsight.com/training/courses/TableOfContents?courseName=implementing-restful-aspdotnet-web-api" rel="external nofollow noreferrer">http://pluralsight.com/training/courses/TableOfContents?courseName=implementing-restful-aspdotnet-web-api</a>（英文的，而且收费，唉。。 亚历山大）</p>
<p><strong>为单个资源返回Http状态码：</strong></p>
<p>Web Api框架中有一个”HttpResponseMessage“类可以用来返回Http状态码。有的时候使用状态码代替model来响应给客户端会更好，下面的例子就是在“Courses‘中的Getcourse(int id)方法中响应一个状态码。下面是我们最终修改后的CoursesController的代码：</p>
<pre>public class CoursesController : BaseApiController
    {
        public CoursesController(ILearningRepository repo)
            : base(repo)
        {
        }

        public IEnumerable&lt;CourseModel&gt; Get()
        {
            IQueryable&lt;Course&gt; query;

            query = TheRepository.GetAllCourses();

            var results = query
                          .ToList()
                          .Select(s =&gt; TheModelFactory.Create(s));

            return results;
        }

        public HttpResponseMessage GetCourse(int id)
        {
            try
            {
                var course = TheRepository.GetCourse(id);
                if (course != null)
                {
                    return Request.CreateResponse(HttpStatusCode.OK, TheModelFactory.Create(course));
                }
                else
                {
                    return Request.CreateResponse(HttpStatusCode.NotFound);
                }

            }
            catch (Exception ex)
            {
                return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ex);
            }
        }
    }</pre>
<p>总结</p>
<p>到此为止我们总共完成了以下的改变：</p>
<p>   1.将”ILearningRepository“注入到”CoursesController“的构造函数中</p>
<p>   2.使用模型工厂模式创建了CourseModel以及关联属性ToturModel和SubjectModel</p>
<p>  3.当资源没找到时我们返回404的状态码，发生异常我们返回400（badRequest）状态码，成功时返回200状态码</p>
<p>为了测试结果，我们发送一个Get请求（<strong><a href="http://localhost/api/courses" rel="external nofollow noreferrer">http://localhost:{<em>your_port</em>}/api/courses</a></strong>）在这里我们很好的控制了模型的返回字段，同时也解决了对象间循环依赖的问题：</p>
<pre>[
    {
        "id": 1,
        "url": "http://localhost:3300/api/courses/1",
        "name": "History Teaching Methods 1",
        "duration": 3,
        "description": "The course will talk in depth about: History Teaching Methods 1",
        "tutor": {
            "id": 1,
            "email": "Ahmad.Joudeh@outlook.com",
            "userName": "AhmadJoudeh",
            "firstName": "Ahmad",
            "lastName": "Joudeh",
            "gender": 0
        },
        "subject": {
            "id": 1,
            "name": "History"
        }
    },
    {
        "id": 2,
        "url": "http://localhost:3300/api/courses/2",
        "name": "History Teaching Methods 2",
        "duration": 3,
        "description": "The course will talk in depth about: History Teaching Methods 2",
        "tutor": {
            "id": 1,
            "email": "Ahmad.Joudeh@outlook.com",
            "userName": "AhmadJoudeh",
            "firstName": "Ahmad",
            "lastName": "Joudeh",
            "gender": 0
        },
        "subject": {
            "id": 1,
            "name": "History"
        }
    },</pre>
<p>下一章我们来解释Http方法（put，post，delete）。</p>
<p>本章代码：<a href="http://pan.baidu.com/s/1ntjq5Dn" rel="external nofollow noreferrer">http://pan.baidu.com/s/1ntjq5Dn</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:54:23</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/create/" title="Create">Create</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/asp/" title="asp">asp</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/web/" title="web">web</a>, <a href="https://www.iamivan.net/tag/api/" title="api">api</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/kernel/" title="kernel">kernel</a>, <a href="https://www.iamivan.net/tag/rest/" title="REST">REST</a>, <a href="https://www.iamivan.net/tag/%e9%a2%86%e5%9f%9f%e6%a8%a1%e5%9e%8b/" title="领域模型">领域模型</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用ASP.NET Web Api构建基于REST风格的服务实战系列教程【四】——实现模型工厂，依赖注入以及格式配置的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKaOAz.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【十】&mdash;&mdash;使用CacheCow和ETag缓存资源</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[十]--使用CacheCow和ETag缓存资源 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 本文将使用一个开源框架CacheCow来实现针对Http请求资源缓存,本文主要介绍服务器端的缓存. 使用缓存技术可以很好的提高Web Api的性能,减小服务器的开销.我们把这种缓存形式称之为:条件化请求(Conditional Requests).具体表现为:客户			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Zaxrp.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【开篇】【持续更新中。。。】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[开篇][持续更新中...] 最近发现web api很火,园内也有各种大神已经在研究,本人在asp.net官网上看到一个系列教程,原文地址:http://bitoftech.net/2013/11/25/detailed-tutorial-building-asp-net-web-api-restful-service/.于是打算跟着学一下,把学习过程记录在博客园的同时也分享给大家. 每一篇结束后我都会把代码共享 由于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8YAY3z.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【三】&mdash;&mdash;Web Api入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[三]--Web Api入门 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 经过前2节的介绍,我们已经把数据访问层搭建好了,从本章开始就是Web Api部分了.在正式开始之前,再一次回顾一下Web Api的应用场景:Web Api可以与 MVC,WebForm结合使用,也可以作为一个单独的Web服务.在正式讨论Web Api的配置以及如何构造我们的URI来消			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJZanp.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【外传】&mdash;&mdash;Attribute Routing</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[外传]--Attribute Routing 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 题外话:由于这个技术点是新学的,并不属于原系列,但借助了原系列的项目背景,故命名外传系列,以后也可能在这个系列中附加一些新的技术. 前言 在Web Api 2.0中,提出了一种新的配置路由方式--基于特性的路由(Attribute-based Routing),在我们之前			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1kRxb.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【七】&mdash;&mdash;实现资源的分页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[七]--实现资源的分页 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 这篇文章我们将使用不同的方式实现手动分页(关于高端大气上档次的OData本文暂不涉及,但有可能会在系列的后期介绍,还没确定...),对于分页的结果,我们将采用2种不同的方式响应给客户端(1.将分页元数据封装在响应Body中2.在http响应报文头部添加分页信息). 众所周知,在服务器端一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdvWexb.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【五】&mdash;&mdash;在Web Api中实现Http方法&lpar;Put&comma;Post&comma;Delete&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[五]--在Web Api中实现Http方法(Put,Post,Delete) 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 在Web Api中,我们对资源的CRUD操作都是通过相应的Http方法来实现--Post(新增),Put(修改),Delete(删除),Get(查询).查询在前几章我们已经实现了,本章就在我们的案列(CourseController)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdB2R6b.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【六】&amp;amp&semi;mdash&semi;&amp;amp&semi;mdash&semi;实现资源间的关联</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[六]--实现资源间的关联 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 这一篇文章主要介绍一下资源间的关联--例如在学生和课程之间就存在这样的关联:每一个课程都会有多个学生来选,如何获取这些有关联的信息?如何实现选课的业务?对于客户端应该怎么来调用呢?下面给出解决方案: 配置对应的路由 对于上面的需求,我们可以先定制一个URI模板:&quot;api/courses			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9WE4dz.html" rel="bookmark">使用ASP&period;NET Web Api构建基于REST风格的服务实战系列教程【八】&mdash;&mdash;Web Api的安全性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:使用ASP.NET Web Api构建基于REST风格的服务实战系列教程[八]--Web Api的安全性 系列导航地址http://www.cnblogs.com/fzrain/p/3490137.html 前言 这一篇文章我们主要来探讨一下Web Api的安全性,到目前为止所有的请求都是走的Http协议(http://),因此客户端与服务器之间的通信是没有加密的.在本篇中,我们将在&quot;StudentController&quot;中添加身份验证功能--通过验证用户名与密码来判断是否是合法用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6e4WWb.html" rel="bookmark">通过Knockout&period;js &plus; ASP&period;NET Web API构建一个简单的CRUD应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				较之面向最终消费者的网站,企业级Web应用对用户体验的要求要低一些.不过客户对&quot;用户体验&quot;的要求是&quot;与日俱增&quot;的,很多被&quot;惯坏了&quot;的用户已经不能忍受Postback带来的页面刷新,所以Ajax在企业级Web应用中得到了广泛的应用.企业级Web应用的一个特点是以&quot;数据处理&quot;为主,所以&quot;面向绑定&quot;的Knockout.js 是一个不错的选择.ASP.NET Web API,作为.NET平台最好的REST服务开发平			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5ZaDz.html" rel="bookmark" class="title">简单字符串转换</a>
					<div>
						在做字符串.文本操作时,我们时常会需要在wchar_t *和char *之间做转换或搭桥.直 接用API,参数太多不容易记住,常常要查文档,浪费不少时间.为了自己方便,对简单的转 换写了一个简单的转换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlm1Np.html" rel="bookmark" class="title">【整理】WEB 容器、WEB服务和应用服务器的区别与联系</a>
					<div>
						对于一个不了解 WEB 开发的人来说,下面的概念是为了免于被别人鄙视和忽悠的~~  [web 容器]  何为容器:       容器是一种服务调用规范框架,J2EE 大量运用了容器和组件技术来构建分层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEOr9p.html" rel="bookmark" class="title">自我参考：Java学习的30个目标</a>
					<div>
						参考 本文将告诉你学习Java需要达到的30个目标,希望能够对你的学习有所帮助.对比一下自己,你已经掌握了这30条中的多少条了呢? 1.你需要精通面向对象分析与设计(OOA/OOD).涉及模式(GOF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWZgmb.html" rel="bookmark" class="title">各地出重拳打击淫秽色情网站和非法出版物</a>
					<div>
						CCTV.com消息(新闻联播):全国&quot;扫黄打非&quot;春季战役开展以来,各地成功打掉了一批淫秽色情网站,集中销毁了大量盗版产品和非法出版物. 日前,吉林警方在长春某小区端掉了一个利用互 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNllDb.html" rel="bookmark" class="title">跟我一起云计算（2） YARN</a>
					<div>
						介绍 Apache Hadoop YARN作为hadoop的子项目加入到Hadoop Common (core libraries), Hadoop HDFS (storage) and Hadoop ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4PWOp.html" rel="bookmark" class="title">Equinox OSGi服务器应用程序的配置步骤</a>
					<div>
						本文介绍在Eclipse里如何配置一个简单的基于Eclipse Equinox OSGi实现的Web应用程序,在它的基 础上可以构造更加复杂的应用,本文使用的是Eclipse 3.3.1版本,如果你的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6jojz.html" rel="bookmark" class="title">HTC Android手机字库</a>
					<div>
						字库,又称FLASH,为Flash ROM闪速只读存储器. 它以代码的形式装载了手机的基本程序和各种功能程序.至今字库这个名词概念混,很不清楚,到底字库是什么呢? 实际上我们可以这样区分,把它们分开叫 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7Dl7b.html" rel="bookmark" class="title">Excel2010如何合并单元格？</a>
					<div>
						  1.打开需要合并单元格的Excel表格 2.选中需要合并的单元格,接着点击工具栏的&quot;开始&quot;→&quot;合并后居中&quot; 3.这个时候我们就会发现表格中的单元格已经合并了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGXo6p.html" rel="bookmark" class="title">教你Windows XP帐户安全三妙招</a>
					<div>
						  在开始菜单中打开运行对话框,输入&quot;Gpedit.msc&quot;打开组策略编辑器,依次浏览到&quot;本地计算机策略&quot;--&quot;计算机配置&quot;--&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7vy9M.html" rel="bookmark" class="title">IntersectionObserver API 使用教程</a>
					<div>
						网页开发时,常常需要了解某个元素是否进入了&quot;视口&quot;(viewport),即用户能不能看到它. 上图的绿色方块不断滚动,顶部会提示它的可见性. 传统的实现方法是,监听到scroll事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPaP8p.html" rel="bookmark" class="title">Android中调用系统所装的软件打开文件</a>
					<div>
						应用中如何调用系统所装的软件打开一个文件,这是我们经常碰到的问题,下面是我所用到的一种方法,和大家一起分享一下! 这个是打开文件的一个方法:   /** * 打开文件 * @param file */ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kWgVM.html" rel="bookmark" class="title">ios-iPhon密码锁屏音乐停止播放</a>
					<div>
						问题描述 iPhon密码锁屏音乐停止播放 最近在开发一个iOS的音乐播放器,遇到了一个Bug: 在没有锁屏的情况下,播放是正常的,当锁屏时(没有设密码),播放音乐也是没有问题的: 但是当密码锁屏时(设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RxXnz.html" rel="bookmark" class="title">你知道你的电脑1秒钟能做多少事情吗？（转）</a>
					<div>
						英文原文:DO YOU KNOW HOW MUCH YOUR COMPUTER CAN DO IN A SECOND? 让我们来看看你有多么了解电脑!所有这些程序的数值都是可变的.你的任务是:在程序花 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRQl3b.html" rel="bookmark" class="title">matlab里运用db4小波分解维数出现问题</a>
					<div>
						问题描述 matlab里运用db4小波分解维数出现问题 wname='db4'; [Lo_D,Hi_D,Lo_R,Hi_R]=wfilters(wname); % subplot(2,2,1); %  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rV7mz.html" rel="bookmark" class="title">BurpSuite实例教程讲解</a>
					<div>
						很久以前就看到了Burp suite这个工具了,当时感觉好NB,但全英文的用起来很是蛋疼,网上也没找到什么教程,就把这事给忘了.今天准备开始好好学习这个渗透神器,也正好给大家分享下.(注:内容大部分是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5vqBM.html" rel="bookmark" class="title">Server Develop （八） IOCP模型</a>
					<div>
						IOCP全称I/O Completion Port,中文译为I/O完成端口.IOCP是一个异步I/O的Windows API,它可以高效地将I/O事件通知给应用程序,类似于Linux中的Epoll.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEW9lM.html" rel="bookmark" class="title">使用JWT的OAuth2的SSO分析</a>
					<div>
						参考:https://github.com/spring-guides/tut-spring-security-and-angular-js/blob/master/oauth2/README.ado ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRaD4b.html" rel="bookmark" class="title">Java实现全排列、组合算法</a>
					<div>
						全排列 解法一: 输入一串字符,然后对字符进行全排列,如&quot;abc&quot;,全排列结果为:&quot;abc&quot;,&quot;acb&quot;,&quot;bac&quot;,& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY56elM.html" rel="bookmark" class="title">php学习笔记 面向对象中&lbrack;接口&rsqb;与&lbrack;多态性&rsqb;的应用&lowbar;php基础</a>
					<div>
						复制代码 代码如下: &lt;?php /* 接口技术 * * 接口是一种特殊的抽象类,抽象类又是一种特殊的类 * * 接口和抽象类是一样的作用 * * 因为在PHP是单继承的,如果使用抽象类,子类实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmPDqM.html" rel="bookmark" class="title">《马里奥赛车8》包含了 GPL 代码</a>
					<div>
						任天堂的游戏机操作系统和软件包含了大量开源代码.这些开源软件是在GPLv2.LGPL或MPL下开源的,根据许可证要求任天堂必须公开其修改的源代码.这家最近不断亏损的日本游戏机公司设立了一个专门网页公布 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodyNBM.html" rel="bookmark" class="title">我打包后的程序在别人的机子上运行怎么就没有数据了？</a>
					<div>
						问题描述 谢谢 解决方案 解决方案二:数据库的路径解决方案三:具体描述一下你的程序是干什么的,数据是程序的后台数据库吗?解决方案四:你的数据,是数据文件,还是数据库?如果是数据库,看看连接字符串是否正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60jKOz.html" rel="bookmark" class="title">请教一个穷举的算法：）列出字符串</a>
					<div>
						问题描述 问题描述:现在想从ABCD四个字符想穷举后得到:ABCDAAABACADAAAAABAACAADABAABBABCABDACAACBACCACDADAADBADCADD.....DDDDD等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAED9JM.html" rel="bookmark" class="title">民航系统软件开发有什么特点</a>
					<div>
						问题描述 如题??用C#.NET...从来没做过这方面的.想知道民航系统开发与其他软件开发有什么区别吗??有哪位高手知道,给讲一下.. 解决方案 解决方案二:听听.解决方案三:.........解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBe6Bz.html" rel="bookmark" class="title">菜价回落绿叶菜普降三四成上海加大蔬菜供应</a>
					<div>
						本市加大蔬菜供应 总体价格趋稳 随着气温回升菜价还将进一步下降 早报记者 俞凯 邹娟 近段时间以来本市蔬菜价格持续波动引起广大市民关注.记者昨日走访沪上部分菜场发现,本市蔬菜价格已有松动迹象,总体价格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr22yWM.html" rel="bookmark" class="title">asp 标记字符串中指定字符变色不区分大小写&lowbar;应用技巧</a>
					<div>
						普通的替换函数 复制代码 代码如下: public function HighLight(S,F) dim tL,tM,tR,k tL=&quot;&quot; tM=&quot;&quot; tR= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jAvvp.html" rel="bookmark" class="title">P3P Header解决Cookie跨域的问题&lowbar;javascript技巧</a>
					<div>
						P3P P3P是一種被稱為個人隱私安全平臺項目(the Platform for Privary Preferences)的標準,能夠保護在線隱私權,使Internet衝浪者可以選擇在瀏覽網頁時,是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2DX5z.html" rel="bookmark" class="title">&period;net 获取浏览器Cookie&lpar;包括HttpOnly&rpar;实例分享&lowbar;实用技巧</a>
					<div>
						一.接口文件 复制代码 代码如下: using System; using System.ComponentModel; using System.Net; using System.Runtime. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKq1P5p.html" rel="bookmark" class="title">快速让网站流量涨起的方法</a>
					<div>
						一:明确长尾词的选择 从简单的字面上理解,长尾词就是&quot;带有尾巴的词&quot;,虽然有些滑稽,但是确实可以如此认为.作为长尾词最显著的特点就是主关键词的延伸.如:&quot;SEO&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVQK7z.html" rel="bookmark" class="title">c&num;-怎么将excel中数据用C&num;读取并存在一个数组中？</a>
					<div>
						问题描述 怎么将excel中数据用C#读取并存在一个数组中? 如图,excel中数据怎么放入c#的数组中,如a[0,0]=22200,a[1,0]=21500 解决方案 一般读取EXCEL都是到数据表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GgRYp.html" rel="bookmark" class="title">使用asp&period;net模拟购物车</a>
					<div>
						问题描述 使用asp.net模拟购物车添加商品怎么做啊,初学不懂,请各位高手指导!!! 解决方案 解决方案二:Session+list&lt;商品类&gt;					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
